package worldcontrolteam.worldcontrol;

import net.minecraft.creativetab.CreativeTabs;
import net.minecraft.item.ItemBlock;
import net.minecraft.item.ItemStack;
import net.minecraft.util.NonNullList;
import net.minecraftforge.fml.relauncher.Side;
import net.minecraftforge.fml.relauncher.SideOnly;
import worldcontrolteam.worldcontrol.init.WCContent;
import worldcontrolteam.worldcontrol.items.ItemBaseCard;
import worldcontrolteam.worldcontrol.items.ItemBaseKit;
import worldcontrolteam.worldcontrol.utils.WCUtility;

public class WCCreativeTab extends CreativeTabs {

    public WCCreativeTab() {
        super("World Control");
    }

    @Override
    @SideOnly(Side.CLIENT)
    public ItemStack func_78016_d() {
        return new ItemStack(WCContent.REMOTE_PANEL);
    }

    @Override
    @SideOnly(Side.CLIENT)
    public String func_78024_c() {
        return WCUtility.translate("creativetab");
    }

    @SideOnly(Side.CLIENT)
    public void func_78018_a(NonNullList<ItemStack> items) {
        super.func_78018_a(items);
        sortList(items);
    }

    private void sortList(NonNullList<ItemStack> items) {
        items.removeIf(s -> s.func_77973_b() instanceof ItemBaseCard && ((ItemBaseCard) s.func_77973_b()).hasKit());
        items.sort((stack1, stack2) -> {
            boolean s1b = stack1.func_77973_b() instanceof ItemBlock;
            boolean s2b = stack2.func_77973_b() instanceof ItemBlock;
            boolean s1k = stack1.func_77973_b() instanceof ItemBaseKit;
            boolean s2k = stack2.func_77973_b() instanceof ItemBaseKit;
            boolean s1c = stack1.func_77973_b() instanceof ItemBaseCard;
            boolean s2c = stack2.func_77973_b() instanceof ItemBaseCard;
            return s1b && s2b ? 0 : s1b ? -1 : s2b ? 1 : s1k && s2k ? 0 : s1k ? -1 : s2k ? 1 : s1c && s2c ? 0 : s1c ? -1 : s2c ? 1 : 1;
        });
        items.forEach(s -> {
            if (s.func_77973_b() instanceof ItemBaseKit) {
                int i = items.indexOf(s);
                items.add(i + 1, new ItemStack(((ItemBaseKit) s.func_77973_b()).getCardType()));
            }
        });
    }
}
