package worldcontrolteam.worldcontrol.client.gui;

import net.minecraft.client.gui.inventory.GuiContainer;
import net.minecraft.client.renderer.GlStateManager;
import net.minecraft.client.resources.I18n;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.entity.player.InventoryPlayer;
import net.minecraft.item.ItemStack;
import net.minecraft.util.ResourceLocation;
import org.lwjgl.opengl.GL11;
import worldcontrolteam.worldcontrol.api.card.ICard;
import worldcontrolteam.worldcontrol.api.card.predefs.StringWrapper;
import worldcontrolteam.worldcontrol.api.screen.IScreenElement;
import worldcontrolteam.worldcontrol.inventory.InventoryItem;
import worldcontrolteam.worldcontrol.inventory.container.ContainerRemotePanel;
import worldcontrolteam.worldcontrol.network.ChannelHandler;
import worldcontrolteam.worldcontrol.network.messages.PacketServerRemotePanel;
import worldcontrolteam.worldcontrol.utils.WCUtility;

import java.util.LinkedList;
import java.util.List;

public class GuiRemotePanel extends GuiContainer {

    private InventoryItem inv;
    private ItemStack lastCard = null;
    private IScreenElement isce;
    private EntityPlayer e;

    public GuiRemotePanel(InventoryPlayer inv, ItemStack stack, InventoryItem inventoryItem, EntityPlayer player) {
        super(new ContainerRemotePanel(inv, stack, inventoryItem));
        this.inv = inventoryItem;
        this.e = player;
    }

    @Override
    public void func_73866_w_() {
        super.func_73866_w_();
        this.field_146999_f += 50;
        this.field_146297_k.field_71439_g.field_71070_bA = this.field_147002_h;
        this.field_147003_i = (this.field_146294_l - this.field_146999_f) / 2;
        this.field_147009_r = (this.field_146295_m - this.field_147000_g) / 2;
    }

    @Override
    protected void func_146976_a(float par1, int par2, int par3) {
        GL11.glColor4f(1.0f, 1.0f, 1.0f, 1.0f);
        this.field_146297_k.field_71446_o.func_110577_a(new ResourceLocation("worldcontrol", "textures/gui/gui_remote_panel.png"));
        int x = (field_146294_l - field_146999_f) / 2;
        int y = (field_146295_m - field_147000_g) / 2;
        this.func_73729_b(x, y, 0, 0, 204, field_147000_g);
    }

    private void updateScreenElement(ItemStack itemInInventory) {
        if (itemInInventory != lastCard) {
            lastCard = itemInInventory;
            isce = null;
            if (itemInInventory.func_77973_b() instanceof ICard) {
                isce = ((ICard) itemInInventory.func_77973_b()).getRenderer(itemInInventory);
            }
        }
    }

    @Override
    protected void func_146979_b(int par1, int par2) {
        List<StringWrapper> joinedData = new LinkedList<StringWrapper>();
        boolean anyCardFound = true;
        InventoryItem itemInv = new InventoryItem(e.func_184614_ca());

        if (!inv.func_70301_a(0).func_190926_b() && !itemInv.func_70301_a(0).func_190926_b() && itemInv.func_70301_a(0).func_77973_b() instanceof ICard) {
            ICard card = (ICard) inv.func_70301_a(0).func_77973_b();
            // CardWrapperImpl helper = new
            // CardWrapperImpl(itemInv.getStackInSlot(0), 0);
            updateScreenElement(itemInv.func_70301_a(0));
            ChannelHandler.network.sendToServer(new PacketServerRemotePanel(inv.func_70301_a(0)));
            if (isce != null) {
                //CardState cs = card.update(e.world, inv.getStackInSlot(0));
                isce.onCardUpdate(e.field_70170_p, itemInv.func_70301_a(0));
                drawCardStuff(true);
            }
            else {
                // todo: add getRemoteCustomMSG back here
            }
        }
    }

    private List<StringWrapper> getRemoteCustomMSG() {
        StringWrapper line = new StringWrapper();
        List<StringWrapper> result = new LinkedList<StringWrapper>();
        line.textCenter = I18n.func_135052_a("nc.msg.notValid");
        result.add(line);
        line = new StringWrapper();
        line.textCenter = I18n.func_135052_a("nc.msg.notValid2");
        result.add(line);
        line = new StringWrapper();
        line.textCenter = "";
        result.add(line);
        line = new StringWrapper();
        line.textCenter = I18n.func_135052_a("nc.msg.notValid3");
        result.add(line);
        return result;
    }

    private void drawCardStuff(Boolean anyCardFound) {
        if (!anyCardFound) {
            WCUtility.error("This should never happen. If you see this report immediately to WC repo. Include GuiRemoteMonitorError-123 in the report!");
            return;
        }

        int x = (field_146294_l - field_146999_f) / 2;
        int y = (field_146295_m - field_147000_g) / 2;

        GlStateManager.func_179094_E();
        GlStateManager.func_179109_b(9, 0, 0);

        isce.draw(158, field_147000_g); // technically should work... i hope

        GlStateManager.func_179121_F();

        // todo: fixme plz
    }

    @Override
    public void func_73876_c() {
        super.func_73876_c();

        if (this.e.func_184614_ca().func_190926_b())
            this.field_146297_k.field_71439_g.func_71053_j();
    }
}
