package worldcontrolteam.worldcontrol.crossmod.industrialcraft2.blocks;

import ic2.api.reactor.IReactor;
import ic2.api.reactor.IReactorChamber;
import net.minecraft.tileentity.TileEntity;
import net.minecraft.util.EnumFacing;
import net.minecraft.util.math.BlockPos;
import worldcontrolteam.worldcontrol.blocks.BlockBasicRotate;
import worldcontrolteam.worldcontrol.crossmod.industrialcraft2.ReactorUtils;
import worldcontrolteam.worldcontrol.tileentity.TileEntityBaseReactorHeatMonitor;

public class TileEntityIC2ReactorMonitor extends TileEntityBaseReactorHeatMonitor {

    @Override
    public int getCurrentHeat() {
        BlockPos ref = this.getReferenceBlock();
        if (ref != null) {
            IReactor reactor = ReactorUtils.getReactorAt(field_145850_b, ref);
            if (reactor != null) {
                return reactor.getHeat();
            }
        }
        return -1;
    }

    @Override
    public boolean isConnectionValid() {
        EnumFacing facing = this.func_145831_w().func_180495_p(this.func_174877_v()).func_177229_b(BlockBasicRotate.FACING);
        this.setReferenceBlock(this.func_174877_v().func_177972_a(facing.func_176734_d()));
        TileEntity tile = func_145831_w().func_175625_s(this.getReferenceBlock());
        if (tile instanceof IReactor || tile instanceof IReactorChamber) {
            return true;
        }
        return false;
    }
}
