package worldcontrolteam.worldcontrol.utils;


import net.minecraft.block.properties.PropertyBool;
import net.minecraft.init.Blocks;
import net.minecraft.tileentity.TileEntity;
import net.minecraft.util.EnumFacing;
import net.minecraft.util.math.BlockPos;
import net.minecraft.world.World;

public class RedstoneHelper {

    public static final PropertyBool POWERED = PropertyBool.func_177716_a("powered");

    private static boolean isPoweredWire(World world, BlockPos pos) {
        return world.func_180495_p(pos).func_177230_c() == Blocks.field_150488_af && Blocks.field_150488_af.func_176211_b(world.func_180495_p(pos), world, pos, EnumFacing.DOWN) > 0;
    }

    public static void checkPowered(World world, TileEntity tileentity) {
        if (world != null && tileentity != null && tileentity instanceof IRedstoneConsumer) {
            boolean powered = world.func_175640_z(tileentity.func_174877_v())
                    || isPoweredWire(world, tileentity.func_174877_v().func_177982_a(1, 0, 0))
                    || isPoweredWire(world, tileentity.func_174877_v().func_177982_a(-1, 0, 0))
                    || isPoweredWire(world, tileentity.func_174877_v().func_177982_a(0, 0, 1))
                    || isPoweredWire(world, tileentity.func_174877_v().func_177982_a(0, 0, -1));
            ((IRedstoneConsumer) tileentity).setPowered(powered);
        }
    }


    public interface IRedstoneConsumer {
        boolean getPowered();

        void setPowered(boolean value);
    }
}
